commit 072b2cdb620767c283f1329e95c7d4d35686596e
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Feb 3 21:37:27 2023 +0100

    fortran: Fix up hash table usage in gfc_trans_use_stmts [PR108451]
    
    The first testcase in the PR (which I haven't included in the patch because
    it is unclear to me if it is supposed to be valid or not) ICEs since extra
    hash table checking has been added recently.  The problem is that
    gfc_trans_use_stmts does
              tree *slot = entry->decls->find_slot_with_hash (rent->use_name, hash,
                                                              INSERT);
              if (*slot == NULL)
    and later on doesn't store anything into *slot and continues.  Another spot
    a few lines later correctly clears the slot if it decides not to use the
    slot, so the following patch does the same.
    
    2023-02-03  Jakub Jelinek  <jakub@redhat.com>
    
            PR fortran/108451
            * trans-decl.c (gfc_trans_use_stmts): Call clear_slot before
            doing continue.
    
    (cherry picked from commit 76f7f0eddcb7c418d1ec3dea3e2341ca99097301)

diff --git a/gcc/fortran/trans-decl.c b/gcc/fortran/trans-decl.c
index b616db34c3f..897928a327f 100644
--- a/gcc/fortran/trans-decl.c
+++ b/gcc/fortran/trans-decl.c
@@ -5408,7 +5408,11 @@ gfc_trans_use_stmts (gfc_namespace * ns)
 	      /* Sometimes, generic interfaces wind up being over-ruled by a
 		 local symbol (see PR41062).  */
 	      if (!st->n.sym->attr.use_assoc)
-		continue;
+		{
+		  *slot = error_mark_node;
+		  entry->decls->clear_slot (slot);
+		  continue;
+		}
 
 	      if (st->n.sym->backend_decl
 		  && DECL_P (st->n.sym->backend_decl)

